/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT4.dat, Mon Sep  5 11:14:32 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001713 (5907)
 *     Revision         0x01
 *     Checksum         0xFE
 *     OEM ID           "HP    "
 *     OEM Table ID     "159B    "
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20100121 (537919777)
 */
DefinitionBlock ("SSDT4.aml", "SSDT", 1, "HP    ", "159B    ", 0x00001000)
{
    External (SGMD)
    External (NSTE)
    External (CSTE)
    External (ASLB, MethodObj)    // 1 Arguments
    External (LIDS, MethodObj)    // 0 Arguments
    External (DSEN)
    External (PWRS, IntObj)
    External (NDID)
    External (DID8)
    External (DID7)
    External (DID6)
    External (DID5)
    External (DID4)
    External (DID3)
    External (DID2)
    External (DID1)
    External (PEBS)
    External (IGDS)
    External (AMDA, MethodObj)    // 1 Arguments
    External (\XBAS, MethodObj)    // 1 Arguments
    External (\_SB_.LID0)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.GFX0.CLID)
    External (\_SB_.PCI0.GFX0.AINT, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.GFX0.GHDS, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.GFX0.GLID, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (\_SB_.PCI0.LPCB.H_EC.SCAN)
    External (\_SB_.PCI0.PEG0.VGA_.LCD0)
    External (\_SB_.PCI0.LPCB.EC0_.DGMS)
    External (\_SB_.PCI0.LPCB.EC0_.NLID)
    External (\_SB_.PCI0.LPCB.EC0_.ECOK)

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (GPIO, SystemIO, 0x0500, 0x60)
        Field (GPIO, ByteAcc, Lock, Preserve)
        {
                    Offset (0x0C), 
                ,   4, 
            PO04,   1, 
                ,   12, 
            PI17,   1, 
                    Offset (0x38), 
                ,   4, 
            PO36,   1, 
                ,   2, 
            PI39,   1, 
                ,   4, 
            PI44,   1, 
                ,   7, 
            PO52,   1, 
            PO53,   1, 
            PO54,   1
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (_DSM, 4, Serialized)
        {
            Store (And (Arg2, 0xFF), Local0)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                If (LEqual (Arg2, Zero))
                {
                    If (LEqual (PXMS, One))
                    {
                        Return (Buffer (0x04)
                        {
                            0x01, 0x00, 0x00, 0x00
                        })
                    }

                    Return (Buffer (0x04)
                    {
                        0x03, 0x00, 0x00, 0x00
                    })
                }

                If (LEqual (Arg2, One))
                {
                    If (LEqual (\_SB.PCI0.PEG0.PEGP.PI44, One))
                    {
                        Return (Package (0x07)
                        {
                            0x06, 
                            Package (0x02)
                            {
                                0x80010100, 
                                Buffer (0x04)
                                {
                                    0x01, 0x03, 0x03, 0x00
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010400, 
                                Buffer (0x04)
                                {
                                    0x07, 0x03, 0x03, 0x00
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010301, 
                                Buffer (0x04)
                                {
                                    0x04, 0x03, 0x03, 0x03
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010302, 
                                Buffer (0x04)
                                {
                                    0x09, 0x03, 0x03, 0x03
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010303, 
                                Buffer (0x04)
                                {
                                    0x05, 0x03, 0x03, 0x03
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010306, 
                                Buffer (0x04)
                                {
                                    0x0E, 0x01, 0x01, 0x01
                                }
                            }
                        })
                    }
                    Else
                    {
                        Return (Package (0x07)
                        {
                            0x06, 
                            Package (0x02)
                            {
                                0x80010100, 
                                Buffer (0x04)
                                {
                                    0x01, 0x03, 0x03, 0x00
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010400, 
                                Buffer (0x04)
                                {
                                    0x02, 0x03, 0x03, 0x00
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010301, 
                                Buffer (0x04)
                                {
                                    0x04, 0x03, 0x03, 0x03
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010302, 
                                Buffer (0x04)
                                {
                                    0x09, 0x03, 0x03, 0x03
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010303, 
                                Buffer (0x04)
                                {
                                    0x05, 0x03, 0x03, 0x03
                                }
                            }, 

                            Package (0x02)
                            {
                                0x80010306, 
                                Buffer (0x04)
                                {
                                    0x0E, 0x01, 0x01, 0x01
                                }
                            }
                        })
                    }
                }

                Return (One)
            }

            Return (One)
        }

        OperationRegion (APXM, SystemMemory, AMDA (0x00010400), Field (APXM, AnyAcc, NoLock, Preserve)
            {
                APSG,   128, 
                APSZ,   32, 
                APVR,   32, 
                        Offset (0x100), 
                APXA,   32, 
                RVBS,   32, 
                TVBO,   32, 
                PXEN,   8, 
                        Offset (0x180), 
                NTLE,   16, 
                TLE1,   16, 
                TLE2,   16, 
                TLE3,   16, 
                TLE4,   16, 
                TLE5,   16, 
                TLE6,   16, 
                TLE7,   16, 
                TLE8,   16, 
                TLE9,   16, 
                TL10,   16, 
                TL11,   16, 
                TL12,   16, 
                TL13,   16, 
                TL14,   16, 
                TL15,   16, 
                        Offset (0x200), 
                TGXA,   16, 
                AGXA,   16, 
                GSTP,   8, 
                PXMS,   8, 
                FDSS,   8, 
                DISM,   8, 
                        Offset (0x210), 
                DSWR,   8, 
                EMDR,   8, 
                TSTR,   8, 
                FPSR,   8, 
                SPSR,   8, 
                DCFR,   8, 
                        Offset (0x230), 
                TSTG,   8, 
                TSSI,   8, 
                FPTG,   8, 
                FPSI,   8, 
                SPWS,   8, 
                        Offset (0x250), 
                SUPD,   16, 
                CACD,   16, 
                CCND,   16, 
                NACD,   16, 
                TLST,   8, 
                LDST,   8, 
                        Offset (0x3C0), 
                TVSD,   8, 
                EXPM,   8, 
                BPSD,   16, 
                BSPD,   16, 
                TLSN,   16, 
                        Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
        Method (ATPX, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F0SS)
                CreateWordField (TMP1, 0x02, F0IV)
                CreateDWordField (TMP1, 0x04, F0SF)
                Store (0x08, F0SS)
                Store (One, F0IV)
                If (LEqual (\_SB.PCI0.PEG0.PEGP.PI44, One))
                {
                    Store (0x87, F0SF)
                }
                Else
                {
                    Store (0x8F, F0SF)
                }

                If (LEqual (PXMS, One))
                {
                    Store (0x33, F0SF)
                }

                If (LEqual (And (FDSS, 0x02), 0x02))
                {
                    And (F0SF, 0xFFFFFFFD, F0SF)
                }

                If (LEqual (And (FDSS, One), One))
                {
                    Or (F0SF, 0x02, F0SF)
                }

                Return (TMP1)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F1SS)
                CreateDWordField (TMP2, 0x02, F1VM)
                CreateDWordField (TMP2, 0x06, F1FG)
                Store (0x0A, F1SS)
                If (LEqual (PXMS, One))
                {
                    Store (0x80, F1VM)
                    Store (0x80, F1FG)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.PEG0.PEGP.PI44, One))
                    {
                        Store (Zero, F1VM)
                        Store (Zero, F1FG)
                    }
                    Else
                    {
                        Store (0x40, F1VM)
                        Store (0x40, F1FG)
                    }
                }

                Return (TMP2)
            }

            If (LEqual (Arg0, 0x02))
            {
                CreateWordField (Arg1, Zero, FN2S)
                CreateByteField (Arg1, 0x02, DGPR)
                If (LEqual (DGPR, Zero))
                {
                    GLSC ()
                    \_SB.PCI0.PEG0.PEGP._OFF ()
                    GLSR ()
                    Store (One, IGDS)
                    If (LEqual (\_SB.PCI0.LPCB.EC0.ECOK, One))
                    {
                        If (LEqual (\_SB.PCI0.LPCB.EC0.NLID, One))
                        {
                            Sleep (0x14)
                            Notify (\_SB.LID0, 0x80)
                            Store (Zero, \_SB.PCI0.LPCB.EC0.NLID)
                        }
                    }
                }

                If (LEqual (DGPR, One))
                {
                    GLSC ()
                    \_SB.PCI0.PEG0.PEGP._ON ()
                    GLSR ()
                    Store (Zero, IGDS)
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x03))
            {
                CreateWordField (Arg1, Zero, FN3S)
                CreateWordField (Arg1, 0x02, SDMG)
                GLSC ()
                If (LEqual (SDMG, Zero))
                {
                    If (Zero)
                    {
                        Store (Zero, \_SB.PCI0.PEG0.PEGP.PO52)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.PEG0.PEGP.PO52)
                    }

                    If (LEqual (\_SB.PCI0.LPCB.EC0.ECOK, One))
                    {
                        Store (Zero, \_SB.PCI0.LPCB.EC0.DGMS)
                    }
                }

                If (LEqual (SDMG, One))
                {
                    If (Ones)
                    {
                        Store (Zero, \_SB.PCI0.PEG0.PEGP.PO52)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.PEG0.PEGP.PO52)
                    }

                    If (LEqual (\_SB.PCI0.LPCB.EC0.ECOK, One))
                    {
                        Store (One, \_SB.PCI0.LPCB.EC0.DGMS)
                    }
                }

                GLSR ()
                If (LEqual (\_SB.PCI0.PEG0.PEGP.PI44, One))
                {
                    Sleep (0xFA)
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x04))
            {
                CreateWordField (Arg1, Zero, FN4S)
                CreateWordField (Arg1, 0x02, SIMG)
                GLSC ()
                If (LEqual (SIMG, Zero))
                {
                    If (Zero)
                    {
                        Store (Zero, \_SB.PCI0.PEG0.PEGP.PO54)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.PEG0.PEGP.PO54)
                    }
                }

                If (LEqual (SIMG, One))
                {
                    If (Ones)
                    {
                        Store (Zero, \_SB.PCI0.PEG0.PEGP.PO54)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.PEG0.PEGP.PO54)
                    }
                }

                GLSR ()
                Return (Zero)
            }

            If (LEqual (Arg0, 0x05))
            {
                CreateWordField (Arg1, Zero, FN5S)
                CreateWordField (Arg1, 0x02, TGFX)
                Store (TGFX, TGXA)
                Store (One, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x06))
            {
                CreateWordField (Arg1, Zero, FN6S)
                CreateWordField (Arg1, 0x02, AGFX)
                Store (AGFX, AGXA)
                Store (Zero, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x08))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, NOCN)
                CreateWordField (TMP3, 0x02, CNSS)
                Store (0x0A, NOCN)
                Store (0x32, CNSS)
                CreateByteField (TMP3, 0x04, FLG1)
                CreateByteField (TMP3, 0x05, ATI1)
                CreateByteField (TMP3, 0x06, ADI1)
                CreateWordField (TMP3, 0x07, ACP1)
                Store (0x07, FLG1)
                Store (One, ATI1)
                Store (Zero, ADI1)
                Store (0x0100, ACP1)
                CreateByteField (TMP3, 0x09, FLG2)
                CreateByteField (TMP3, 0x0A, ATI2)
                CreateByteField (TMP3, 0x0B, ADI2)
                CreateWordField (TMP3, 0x0C, ACP2)
                Store (0x07, FLG2)
                Store (One, ATI2)
                Store (One, ADI2)
                Store (0x0100, ACP2)
                CreateByteField (TMP3, 0x0E, FLG3)
                CreateByteField (TMP3, 0x0F, ATI3)
                CreateByteField (TMP3, 0x10, ADI3)
                CreateWordField (TMP3, 0x11, ACP3)
                Store (0x05, FLG3)
                Store (Zero, ATI3)
                Store (Zero, ADI3)
                Store (0x0400, ACP3)
                CreateByteField (TMP3, 0x13, FLG4)
                CreateByteField (TMP3, 0x14, ATI4)
                CreateByteField (TMP3, 0x15, ADI4)
                CreateWordField (TMP3, 0x16, ACP4)
                Store (0x05, FLG4)
                Store (Zero, ATI4)
                Store (One, ADI4)
                Store (0x0110, ACP4)
                CreateByteField (TMP3, 0x18, FLG5)
                CreateByteField (TMP3, 0x19, ATI5)
                CreateByteField (TMP3, 0x1A, ADI5)
                CreateWordField (TMP3, 0x1B, ACP5)
                Store (0x07, FLG5)
                Store (0x07, ATI5)
                Store (Zero, ADI5)
                Store (0x0301, ACP5)
                CreateByteField (TMP3, 0x1D, FLG6)
                CreateByteField (TMP3, 0x1E, ATI6)
                CreateByteField (TMP3, 0x1F, ADI6)
                CreateWordField (TMP3, 0x20, ACP6)
                Store (0x07, FLG6)
                Store (0x07, ATI6)
                Store (One, ADI6)
                Store (Zero, ACP6)
                CreateByteField (TMP3, 0x22, FLG7)
                CreateByteField (TMP3, 0x23, ATI7)
                CreateByteField (TMP3, 0x24, ADI7)
                CreateWordField (TMP3, 0x25, ACP7)
                Store (0x07, FLG7)
                Store (0x09, ATI7)
                Store (Zero, ADI7)
                Store (0x0302, ACP7)
                CreateByteField (TMP3, 0x27, FLG8)
                CreateByteField (TMP3, 0x28, ATI8)
                CreateByteField (TMP3, 0x29, ADI8)
                CreateWordField (TMP3, 0x2A, ACP8)
                Store (0x07, FLG8)
                Store (0x09, ATI8)
                Store (One, ADI8)
                Store (0x0210, ACP8)
                CreateByteField (TMP3, 0x2C, FLG9)
                CreateByteField (TMP3, 0x2D, ATI9)
                CreateByteField (TMP3, 0x2E, ADI9)
                CreateWordField (TMP3, 0x2F, ACP9)
                Store (0x07, FLG9)
                Store (0x09, ATI9)
                Store (Zero, ADI9)
                Store (0x0303, ACP9)
                CreateByteField (TMP3, 0x31, FLGF)
                CreateByteField (TMP3, 0x32, ATIF)
                CreateByteField (TMP3, 0x33, ADIF)
                CreateWordField (TMP3, 0x34, ACPF)
                Store (0x07, FLGF)
                Store (0x0C, ATIF)
                Store (Zero, ADIF)
                Store (0x0306, ACPF)
                Return (TMP3)
            }

            Return (Zero)
        }

        Method (ATRM, 2, Serialized)
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            If (LGreater (Local0, RVBS))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }
    }

    Name (BDFR, 0x000F804C)
    OperationRegion (GPCR, SystemMemory, Or (PEBS, BDFR, BDFR), One)
    Field (GPCR, AnyAcc, NoLock, Preserve)
    {
        GPCT,   1
    }

    Name (GPLS, Zero)
    Method (GLSC, 0, Serialized)
    {
        Store (GPCT, GPLS)
        If (LEqual (GPCT, One))
        {
            Store (Zero, GPCT)
        }
    }

    Method (GLSR, 0, Serialized)
    {
        Store (GPLS, GPCT)
    }

    Method (IDAB, 0, Serialized)
    {
        Store (0x80010100, DID1)
        Store (0x80010400, DID2)
        Store (0x80010301, DID3)
        Store (0x80010302, DID4)
        Store (0x80010303, DID5)
        Store (0x80010306, DID6)
        Store (Zero, DID7)
        Store (Zero, DID8)
        Store (0x06, NDID)
    }

    Method (HGAS, 0, Serialized)
    {
        If (PWRS)
        {
            Store (One, \_SB.PCI0.GFX0.SPWS)
        }
        Else
        {
            Store (0x02, \_SB.PCI0.GFX0.SPWS)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            Store (One, \_SB.PCI0.GFX0.SPSR)
            Notify (\_SB.PCI0.GFX0, 0x81)
        }
    }

    Method (HBRT, 1, Serialized)
    {
        If (And (0x04, DSEN))
        {
            If (LEqual (Arg0, 0x04))
            {
                Notify (\_SB.PCI0.PEG0.VGA.LCD0, 0x87)
            }

            If (LEqual (Arg0, 0x03))
            {
                Notify (\_SB.PCI0.PEG0.VGA.LCD0, 0x86)
            }
        }
    }

    Method (HLSE, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.GLID (LIDS ())
            }
        }
    }

    Method (HDSE, 1, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.GHDS (Arg0)
            }
            Else
            {
                Store (One, \_SB.PCI0.GFX0.DSWR)
                Subtract (\_SB.PCI0.LPCB.H_EC.SCAN, 0x3A, \_SB.PCI0.GFX0.TLST)
                Notify (\_SB.PCI0.GFX0, 0x81)
            }
        }
    }

    Method (HPFS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.AINT (0x02, Zero)
            }
            Else
            {
                Store (One, \_SB.PCI0.GFX0.EMDR)
                If (LEqual (\_SB.PCI0.GFX0.EXPM, 0x02))
                {
                    Store (Zero, \_SB.PCI0.GFX0.EXPM)
                }
                Else
                {
                    Increment (\_SB.PCI0.GFX0.EXPM)
                }

                Notify (\_SB.PCI0.GFX0, 0x81)
            }
        }
    }

    Method (HGLS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                If (\_SB.PCI0.GFX0.GLID (LIDS ()))
                {
                    Or (0x80000000, \_SB.PCI0.GFX0.CLID, \_SB.PCI0.GFX0.CLID)
                }
            }
        }
    }

    Method (FPED, 0, NotSerialized)
    {
        OperationRegion (IGDM, SystemMemory, ASLB (0x2000), Field (IGDM, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x1C04), 
                DDCH,   1024
            })
    }

    Method (PDCC, 0, NotSerialized)
    {
        Store (One, \_SB.PCI0.GFX0.DCFR)
        Notify (\_SB.PCI0.GFX0, 0x81)
    }

    Method (PXPW, 0, Serialized)
    {
        If (PWRS)
        {
            Store (One, \_SB.PCI0.GFX0.SPWS)
        }
        Else
        {
            Store (0x02, \_SB.PCI0.GFX0.SPWS)
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (ATIF, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP0, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP0, Zero, F0SS)
                CreateWordField (TMP0, 0x02, F0IV)
                CreateDWordField (TMP0, 0x04, F0SN)
                CreateDWordField (TMP0, 0x08, F0SF)
                Store (0x0C, F0SS)
                Store (One, F0IV)
                Store (0x51, F0SN)
                Store (0x07, F0SF)
                Return (TMP0)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F1SS)
                CreateDWordField (TMP1, 0x02, F1VF)
                CreateDWordField (TMP1, 0x06, F1FG)
                Store (0x0A, F1SS)
                Store (0x03, F1VF)
                Store (One, F1FG)
                Return (TMP1)
            }

            If (LEqual (Arg0, 0x02))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F2SS)
                CreateDWordField (TMP2, 0x02, F2PR)
                CreateByteField (TMP2, 0x06, F2EM)
                CreateByteField (TMP2, 0x07, F2TG)
                CreateByteField (TMP2, 0x08, F2SI)
                CreateByteField (TMP2, 0x09, F2FG)
                CreateByteField (TMP2, 0x0A, F2FI)
                CreateByteField (TMP2, 0x0B, F2SP)
                Store (0x0A, F2SS)
                Name (STS2, Zero)
                Or (DSWR, STS2, STS2)
                Store (STS2, F2PR)
                Store (Zero, DSWR)
                Return (TMP2)
            }

            If (LEqual (Arg0, 0x03))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, F3SS)
                CreateWordField (TMP3, 0x02, F3SD)
                CreateWordField (Arg1, Zero, AI3S)
                CreateWordField (Arg1, 0x02, SLDS)
                CreateWordField (Arg1, 0x04, CODS)
                Store (SLDS, CACD)
                Store (CODS, CCND)
                Or (CCND, 0x21, CCND)
                Store (0x04, F3SS)
                Store (COTA (CACD), TLSN)
                Store (CACD, CSTE)
                Store (NTLE, Local0)
                While (Local0)
                {
                    Store (NATL (TLSN), Local1)
                    If (LNotEqual (Local1, Zero))
                    {
                        If (LEqual (And (Local1, CCND), Local1))
                        {
                            Store (One, Local0)
                        }
                    }

                    Decrement (Local0)
                    Increment (TLSN)
                    If (LGreaterEqual (TLSN, NTLE))
                    {
                        Store (One, TLSN)
                    }
                }

                Store (Local1, NACD)
                Store (NACD, NSTE)
                Store (NACD, F3SD)
                Return (TMP3)
            }

            Return (Zero)
        }

        Method (COTA, 1, NotSerialized)
        {
            If (LNotEqual (NTLE, Zero))
            {
                If (LEqual (TLE1, Arg0))
                {
                    Return (One)
                }

                If (LEqual (TLE2, Arg0))
                {
                    Return (0x02)
                }

                If (LEqual (TLE3, Arg0))
                {
                    Return (0x03)
                }

                If (LEqual (TLE4, Arg0))
                {
                    Return (0x04)
                }

                If (LEqual (TLE5, Arg0))
                {
                    Return (0x05)
                }

                If (LEqual (TLE6, Arg0))
                {
                    Return (0x06)
                }

                If (LEqual (TLE7, Arg0))
                {
                    Return (0x07)
                }

                If (LEqual (TLE8, Arg0))
                {
                    Return (0x08)
                }

                If (LEqual (TLE9, Arg0))
                {
                    Return (0x09)
                }

                If (LEqual (TL10, Arg0))
                {
                    Return (0x0A)
                }

                If (LEqual (TL11, Arg0))
                {
                    Return (0x0B)
                }

                If (LEqual (TL12, Arg0))
                {
                    Return (0x0C)
                }

                If (LEqual (TL13, Arg0))
                {
                    Return (0x0D)
                }

                If (LEqual (TL14, Arg0))
                {
                    Return (0x0E)
                }

                If (LEqual (TL15, Arg0))
                {
                    Return (0x0F)
                }
            }

            Return (Zero)
        }

        Method (NATL, 1, NotSerialized)
        {
            If (LNotEqual (NTLE, Zero))
            {
                If (LEqual (Arg0, One))
                {
                    Return (TLE2)
                }

                If (LEqual (Arg0, 0x02))
                {
                    Return (TLE3)
                }

                If (LEqual (Arg0, 0x03))
                {
                    Return (TLE4)
                }

                If (LEqual (Arg0, 0x04))
                {
                    Return (TLE5)
                }

                If (LEqual (Arg0, 0x05))
                {
                    Return (TLE6)
                }

                If (LEqual (Arg0, 0x06))
                {
                    Return (TLE7)
                }

                If (LEqual (Arg0, 0x07))
                {
                    Return (TLE8)
                }

                If (LEqual (Arg0, 0x08))
                {
                    Return (TLE9)
                }

                If (LEqual (Arg0, 0x09))
                {
                    Return (TL10)
                }

                If (LEqual (Arg0, 0x0A))
                {
                    Return (TL11)
                }

                If (LEqual (Arg0, 0x0B))
                {
                    Return (TL12)
                }

                If (LEqual (Arg0, 0x0C))
                {
                    Return (TL13)
                }

                If (LEqual (Arg0, 0x0D))
                {
                    Return (TL14)
                }

                If (LEqual (Arg0, 0x0E))
                {
                    Return (TL15)
                }

                If (LEqual (Arg0, 0x0F))
                {
                    Return (TLE1)
                }
            }

            Return (Zero)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (PWRE, 0, Serialized)
        {
            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO04)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO04)
            }

            If (Zero)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO36)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO36)
            }

            Sleep (0x012C)
            If (Zero)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO04)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO04)
            }

            Sleep (0x64)
        }

        Method (PWRD, 0, Serialized)
        {
            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO04)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO04)
            }

            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO36)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO36)
            }
        }
    }

    Scope (\_SB.PCI0.PEG0)
    {
        OperationRegion (RPCI, PCI_Config, Zero, 0xF0)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1
        }

        OperationRegion (RPCX, SystemMemory, \XBAS (0x8400), Field (RPCX, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x8214), 
                        Offset (0x8216), 
                LNKS,   4
            })
        Device (ATHA)
        {
            Name (_ADR, One)
            Name (_PRW, Package (0x02)
            {
                0x09, 
                0x04
            })
            OperationRegion (PCIS, PCI_Config, Zero, 0x0100)
            Field (PCIS, DWordAcc, Lock, Preserve)
            {
                        Offset (0x4C), 
                SSID,   32
            }
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (ELCT, Zero)
        Name (HVID, Zero)
        Name (HDID, Zero)
        OperationRegion (PCIS, PCI_Config, Zero, 0x0100)
        Field (PCIS, DWordAcc, Lock, Preserve)
        {
            DVID,   16, 
                    Offset (0x2C), 
            SVID,   16, 
            SDID,   16, 
                    Offset (0x4C), 
            WVID,   16, 
            WDID,   16
        }

        Name (B0D1, Zero)
        OperationRegion (PCAP, SystemMemory, Or (PEBS, 0x8000, B0D1), 0xC0)
        Field (PCAP, DWordAcc, NoLock, Preserve)
        {
                    Offset (0xB0), 
            LCTL,   16
        }

        Field (PCIS, DWordAcc, Lock, Preserve)
        {
                    Offset (0x4C), 
            SSID,   32
        }

        Field (PCIS, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x04), 
            CMDR,   8, 
            VGAR,   2008
        }

        Name (VGAB, Buffer (0xFB)
        {
            /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0020 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0028 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0030 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0038 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0040 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0048 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0050 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0058 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0060 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0068 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0070 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0078 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0080 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0088 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0090 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0098 */    0x00, 0x00, 0x00
        })
        Name (SGID, Zero)
        Name (AHID, Zero)
        Method (_INI, 0, NotSerialized)
        {
            If (LNotEqual (SSID, Ones))
            {
                Store (Zero, IGDS)
            }
        }

        Method (_ON, 0, Serialized)
        {
            \_SB.PCI0.PEG0.PEGP.PWRE ()
            Store (Zero, LNKD)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            Store (HVID, WVID)
            Store (HDID, WDID)
            Or (And (ELCT, 0x43), And (LCTL, 0xFFBC), LCTL)
            Store (SGID, SSID)
            Store (AHID, \_SB.PCI0.PEG0.ATHA.SSID)
            Notify (\_SB.PCI0.PEG0, Zero)
        }

        Method (_OFF, 0, Serialized)
        {
            Store (LCTL, ELCT)
            Store (SVID, HVID)
            Store (SDID, HDID)
            Store (SSID, SGID)
            Store (\_SB.PCI0.PEG0.ATHA.SSID, AHID)
            Store (One, LNKD)
            While (LLess (LNKS, Zero))
            {
                Sleep (One)
            }

            \_SB.PCI0.PEG0.PEGP.PWRD ()
            Notify (\_SB.PCI0.PEG0, Zero)
        }

        Method (_STA, 0, Serialized)
        {
            If (LEqual (SGMD, One))
            {
                Return (0x0F)
            }
            Else
            {
                Return (Zero)
            }
        }
    }
}

